<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSalaryPreCalculationItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfSalaryPreCalculationItem extends AbstractStructArrayBase
{
    /**
     * The SalaryPreCalculationItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SalaryPreCalculationItem[]
     */
    public $SalaryPreCalculationItem;
    /**
     * Constructor method for ArrayOfSalaryPreCalculationItem
     * @uses ArrayOfSalaryPreCalculationItem::setSalaryPreCalculationItem()
     * @param \StructType\SalaryPreCalculationItem[] $salaryPreCalculationItem
     */
    public function __construct(array $salaryPreCalculationItem = array())
    {
        $this
            ->setSalaryPreCalculationItem($salaryPreCalculationItem);
    }
    /**
     * Get SalaryPreCalculationItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SalaryPreCalculationItem[]|null
     */
    public function getSalaryPreCalculationItem()
    {
        return isset($this->SalaryPreCalculationItem) ? $this->SalaryPreCalculationItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSalaryPreCalculationItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSalaryPreCalculationItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSalaryPreCalculationItemForArrayConstraintsFromSetSalaryPreCalculationItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSalaryPreCalculationItemSalaryPreCalculationItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfSalaryPreCalculationItemSalaryPreCalculationItemItem instanceof \StructType\SalaryPreCalculationItem) {
                $invalidValues[] = is_object($arrayOfSalaryPreCalculationItemSalaryPreCalculationItemItem) ? get_class($arrayOfSalaryPreCalculationItemSalaryPreCalculationItemItem) : sprintf('%s(%s)', gettype($arrayOfSalaryPreCalculationItemSalaryPreCalculationItemItem), var_export($arrayOfSalaryPreCalculationItemSalaryPreCalculationItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SalaryPreCalculationItem property can only contain items of type \StructType\SalaryPreCalculationItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SalaryPreCalculationItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SalaryPreCalculationItem[] $salaryPreCalculationItem
     * @return \ArrayType\ArrayOfSalaryPreCalculationItem
     */
    public function setSalaryPreCalculationItem(array $salaryPreCalculationItem = array())
    {
        // validation for constraint: array
        if ('' !== ($salaryPreCalculationItemArrayErrorMessage = self::validateSalaryPreCalculationItemForArrayConstraintsFromSetSalaryPreCalculationItem($salaryPreCalculationItem))) {
            throw new \InvalidArgumentException($salaryPreCalculationItemArrayErrorMessage, __LINE__);
        }
        if (is_null($salaryPreCalculationItem) || (is_array($salaryPreCalculationItem) && empty($salaryPreCalculationItem))) {
            unset($this->SalaryPreCalculationItem);
        } else {
            $this->SalaryPreCalculationItem = $salaryPreCalculationItem;
        }
        return $this;
    }
    /**
     * Add item to SalaryPreCalculationItem value
     * @throws \InvalidArgumentException
     * @param \StructType\SalaryPreCalculationItem $item
     * @return \ArrayType\ArrayOfSalaryPreCalculationItem
     */
    public function addToSalaryPreCalculationItem(\StructType\SalaryPreCalculationItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SalaryPreCalculationItem) {
            throw new \InvalidArgumentException(sprintf('The SalaryPreCalculationItem property can only contain items of type \StructType\SalaryPreCalculationItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SalaryPreCalculationItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SalaryPreCalculationItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SalaryPreCalculationItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SalaryPreCalculationItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SalaryPreCalculationItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SalaryPreCalculationItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SalaryPreCalculationItem
     */
    public function getAttributeName()
    {
        return 'SalaryPreCalculationItem';
    }
}
